﻿Imports GrxCAD.ApplicationServices
Imports GrxCAD.DatabaseServices
Imports GrxCAD.EditorInput
Imports GrxCAD.Geometry
Imports GrxCAD.Runtime

Public Class sample : Implements IExtensionApplication
	'初期化処理
	Public Sub Initialize() Implements IExtensionApplication.Initialize
		Dim icEd As Editor = Application.DocumentManager.MdiActiveDocument.Editor
		icEd.WriteMessage($"{vbLf}サンプルの.NETアセンブリをロードしました")
	End Sub

	'解放処理
	Public Sub Terminate() Implements IExtensionApplication.Terminate
	End Sub

	<CommandMethod("BREAKSAMPLE")>
	Public Sub BreakSample()
		Dim db = Application.DocumentManager.MdiActiveDocument.Database
		Dim ed = Application.DocumentManager.MdiActiveDocument.Editor
        Dim res1 = ed.GetEntity(vbLf + "点で分割する直線・曲線を選択")
        If res1.Status <> PromptStatus.OK Then Return
		Using trans = db.TransactionManager.StartTransaction()
			Using ent As Entity = trans.GetObject(res1.ObjectId, OpenMode.ForRead)
				If TypeOf ent Is Curve Then
					Dim crv As Curve = ent
					If TypeOf crv Is Circle Or TypeOf crv Is Ellipse Then
						ed.WriteMessage(vbLf + "円、楕円は点で分割できません")
						Return
					End If
					Dim res2 = ed.GetPoint(vbLf + "分割点を指定")
					If res2.Status <> PromptStatus.OK Then Return
					Dim breakPt = crv.GetClosestPointTo(res2.Value, False)
					Dim crvs = crv.GetSplitCurves(New Point3dCollection(New Point3d() {breakPt}))
					If crvs.Count = 0 Then Return
					Dim curSpace As BlockTableRecord = trans.GetObject(db.CurrentSpaceId, OpenMode.ForWrite)
					For Each obj As Curve In crvs
						curSpace.AppendEntity(obj)
						trans.AddNewlyCreatedDBObject(obj, True)
					Next
					crv.UpgradeOpen()
					crv.Erase()
				Else
                    ed.WriteMessage(vbLf + "選択されたオブジェクトは直線・曲線ではありません")
                    Return
				End If
			End Using
			trans.Commit()
		End Using
	End Sub

End Class
